Subject: Re: bug#21428: 24.5; Crash of emacs on OS X, installed via homebrew cask

From: Rainer M Krug <[email-masked]>
Date: Fri, 16 Oct 2015 10:35:11 +0200

Rainer M Krug <[email-masked]> writes:

> Envoyé de mon iPhone
>
> Le 7 oct. 2015 à 17:36, Eli Zaretskii <[email-masked]> a écrit :
>
>>> From: Rainer M Krug <[email-masked]>
>>> Cc: [email-masked],  [email-masked]
>>> Date: Wed, 07 Oct 2015 10:13:31 +0200
>>> 
>>> 1) I started emacs under gdb 7.10,
>>> 2) loaded all buffers as usual in emacs
>>> 3) sourced .gdbinit and your code to enable logging and the additional
>>> breakpoints
>>> 
>>> When starting to fold /unfold, a breakpoint is called and the session quit because of
>>> 
>>> ,----
>>> | Lisp Backtrace:
>>> | [New Thread 0x1c3f of process 1855]
>>> | Cannot access memory at address 0x2018400
>>> `----
>>> 
>>> So this does not seem to help.
>> 
>> Sorry, I was not clear enough: please do NOT source .gdbinit AT ALL.
>> Only source the file with the breakpoints and commands I asked to use.
>> 
>> The contents of the Emacs .gdbinit is responsible for the fact that
>> each time GDB executes the "backtrace" command, it also executes the
>> "xbacktrace" command, which is defined in .gdbinit and causes GDB to
>> call functions inside Emacs, which for some reason fail and stop the
>> entire process.
>
> Ok- will dodo tomorrow. 

OK - I am back. I upgraded my system to OSX El Capitan and I still had
the crashes.

I attach the log (unfortunately the logging was not working as I deleted
the log inbetween, but I attach the shell output which should be the
same).

I leave the session open and enable logging again.

Let me know if you need further info.

Here the output in short:

,----
| (gdb) bt
| #0  0x00007fff98555ada in ?? () from /usr/lib/system/libsystem_kernel.dylib
| #1  0x000000010017d460 in terminate_due_to_signal (sig=6, backtrace_limit=40) at emacs.c:397
| #2  0x00000001001b50a3 in emacs_abort () at sysdep.c:2219
| #3  0x000000010034098e in ns_term_shutdown (sig=6) at nsterm.m:4596
| #4  0x000000010017d753 in shut_down_emacs (sig=6, stuff=0) at emacs.c:2038
| #5  0x000000010017d3fb in terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at emacs.c:381
| #6  0x000000010022a13b in die (msg=0x1003bab33 "face != NULL", file=0x1003b6130 "xdisp.c", line=24386) at alloc.c:6951
| #7  0x00000001000654f7 in get_glyph_face_and_encoding (f=0x102823fa0, glyph=0x113d80060, char2b=0x7fff5fbfb490) at xdisp.c:24386
| #8  0x00000001000b868d in fill_glyph_string (s=0x7fff5fbfb500, face_id=55, start=2, end=55, overlaps=0) at xdisp.c:24611
| #9  0x000000010006fba9 in draw_glyphs (w=0x102822e30, x=26, row=0x113db1100, area=TEXT_AREA, start=0, end=55, hl=DRAW_NORMAL_TEXT, overlaps=0) at xdisp.c:25278
| #10 0x000000010006f4d1 in x_write_glyphs (w=0x102822e30, updated_row=0x113db1100, start=0x113d80000, updated_area=TEXT_AREA, len=55) at xdisp.c:27309
| #11 0x00000001000125da in update_text_area (w=0x102822e30, updated_row=0x113db1100, vpos=1) at dispnew.c:3611
| #12 0x00000001000101f4 in update_window_line (w=0x102822e30, vpos=1, mouse_face_overwritten_p=0x7fff5fbfbda2) at dispnew.c:3854
| #13 0x0000000100007df4 in update_window (w=0x102822e30, force_p=true) at dispnew.c:3477
| #14 0x000000010000696f in update_window_tree (w=0x102822e30, force_p=true) at dispnew.c:3219
| #15 0x000000010000691d in update_window_tree (w=0x112815d80, force_p=true) at dispnew.c:3217
| #16 0x000000010000662b in update_frame (f=0x102823fa0, force_p=true, inhibit_hairy_id_p=false) at dispnew.c:3108
| #17 0x000000010005318f in redisplay_internal () at xdisp.c:13929
| #18 0x0000000100054789 in redisplay () at xdisp.c:13099
| #19 0x0000000100188b89 in read_char (commandflag=1, map=4802148483, prev_event=0, used_mouse_menu=0x7fff5fbfef87, end_time=0x0) at keyboard.c:2465
| #20 0x0000000100183ae9 in read_key_sequence (keybuf=0x7fff5fbff2c0, bufsize=30, prompt=0, dont_downcase_last=false, can_return_switch_frame=true, fix_current_buffer=true, prevent_redisplay=false) at keyboard.c:9030
| #21 0x00000001001823e6 in command_loop_1 () at keyboard.c:1348
| #22 0x0000000100265156 in internal_condition_case (bfun=0x100181df0 <command_loop_1>, handlers=17616, hfun=0x10019d660 <cmd_error>) at eval.c:1309
| #23 0x000000010019d55c in command_loop_2 (ignore=0) at keyboard.c:1088
| #24 0x000000010026421e in internal_catch (tag=42768, func=0x10019d530 <command_loop_2>, arg=0) at eval.c:1073
| #25 0x0000000100181130 in command_loop () at keyboard.c:1067
| #26 0x0000000100180f72 in recursive_edit_1 () at keyboard.c:673
| #27 0x0000000100181363 in Frecursive_edit () at keyboard.c:744
| #28 0x000000010017ef15 in main (argc=1, argv=0x7fff5fbff8c8) at emacs.c:1643
| [New Thread 0x2227 of process 86678]
| 
| Lisp Backtrace:
| Cannot access memory at address 0x9200
| (gdb) source ./src/.gdbinit
| Warning: /Users/rainerkrug/ownCompiled/emacs/../lwlib: No such file or directory.
| SIGINT is used by the debugger.
| Are you sure you want to change it? (y or n) [answered Y; input not from terminal]
| DISPLAY = /private/tmp/com.apple.launchd.myZipTJFNG/org.macosforge.xquartz:0
| TERM = xterm
| Breakpoint 4 at 0x10017d372: file emacs.c, line 370.
| Temporary breakpoint 5 at 0x1001b5e1f: file sysdep.c, line 907.
| (gdb) p c->used
| No symbol "c" in current context.
| (gdb) frame 9
| #9  0x000000010006fba9 in draw_glyphs (w=0x102822e30, x=26, row=0x113db1100, area=TEXT_AREA, start=0, end=55, hl=DRAW_NORMAL_TEXT, overlaps=0) at xdisp.c:25278
| 25278	  BUILD_GLYPH_STRINGS (i, end, head, tail, hl, x, last_x);
| (gdb) pgrow
| [New Thread 0x1a1b of process 86678]
| [New Thread 0x11fb of process 86678]
| [New Thread 0x1693 of process 86678]
| [New Thread 0x20eb of process 86678]
| [New Thread 0x2173 of process 86678]
| TEXT: 55 glyphs
|   0    0: CHAR[*] str=0x134069d0[0] blev=0,btyp=L w=8 a+d=14+4 face=16 AVOID
|   1    8: CHAR[*] pos=37312 blev=0,btyp=L w=8 a+d=14+4 face=16 MB
|   2   16: CHAR[*] pos=37313 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|   3   24: CHAR[ ] pos=37314 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|   4   32: CHAR[T] pos=37315 blev=0,btyp=L w=9 a+d=15+5 face=56 MB [
|   5   41: CHAR[O] pos=37316 blev=0,btyp=L w=8 a+d=15+5 face=56 MB
|   6   49: CHAR[D] pos=37317 blev=0,btyp=L w=8 a+d=15+5 face=56 MB
|   7   57: CHAR[O] pos=37318 blev=0,btyp=L w=9 a+d=15+5 face=56 MB ]
|   8   66: CHAR[ ] pos=37319 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|   9   74: CHAR[[] pos=37320 blev=0,btyp=L w=9 a+d=15+5 face=56 MB [
|  10   83: CHAR[0] pos=37321 blev=0,btyp=L w=8 a+d=15+5 face=56 MB
|  11   91: CHAR[/] pos=37322 blev=0,btyp=L w=8 a+d=15+5 face=56 MB
|  12   99: CHAR[2] pos=37323 blev=0,btyp=L w=8 a+d=15+5 face=56 MB
|  13  107: CHAR[]] pos=37324 blev=0,btyp=L w=9 a+d=15+5 face=56 MB ]
|  14  116: CHAR[ ] pos=37325 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  15  124: CHAR[S] pos=37326 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  16  132: CHAR[e] pos=37327 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  17  140: CHAR[n] pos=37328 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  18  148: CHAR[s] pos=37329 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  19  156: CHAR[i] pos=37330 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  20  164: CHAR[t] pos=37331 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  21  172: CHAR[i] pos=37332 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  22  180: CHAR[v] pos=37333 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  23  188: CHAR[i] pos=37334 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  24  196: CHAR[t] pos=37335 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  25  204: CHAR[y] pos=37336 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  26  212: CHAR[ ] pos=37337 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  27  220: CHAR[a] pos=37338 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  28  228: CHAR[n] pos=37339 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  29  236: CHAR[a] pos=37340 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  30  244: CHAR[l] pos=37341 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  31  252: CHAR[y] pos=37342 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  32  260: CHAR[s] pos=37343 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  33  268: CHAR[i] pos=37344 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  34  276: CHAR[s] pos=37345 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  35  284: CHAR[ ] pos=37346 blev=0,btyp=L w=8 a+d=16+4 face=55 MB
|  36  292: CHAR[E] pos=37347 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  37  300: CHAR[v] pos=37348 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  38  308: CHAR[a] pos=37349 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  39  316: CHAR[p] pos=37350 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  40  324: CHAR[o] pos=37351 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  41  332: CHAR[t] pos=37352 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  42  340: CHAR[r] pos=37353 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  43  348: CHAR[a] pos=37354 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  44  356: CHAR[n] pos=37355 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  45  364: CHAR[s] pos=37356 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  46  372: CHAR[p] pos=37357 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  47  380: CHAR[i] pos=37358 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  48  388: CHAR[r] pos=37359 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  49  396: CHAR[a] pos=37360 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  50  404: CHAR[t] pos=37361 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  51  412: CHAR[i] pos=37362 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  52  420: CHAR[o] pos=37363 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  53  428: CHAR[n] pos=37364 blev=0,btyp=L w=8 a+d=16+4 face=57 MB
|  54  436: CHAR[ ] pos=0 blev=0,btyp=B w=8 a+d=16+5 face=55 MB
| (gdb) frame 7
| #7  0x00000001000654f7 in get_glyph_face_and_encoding (f=0x102823fa0, glyph=0x113d80060, char2b=0x7fff5fbfb490) at xdisp.c:24386
| 24386	  eassert (face != NULL);
| (gdb) p f->face_cache->used
| $14349 = 42
| (gdb) set logging off
| Done logging to gdb.txt.
| (gdb)
`----

Thanks,

Rainer

> Rainer
>> Thanks.

-- 
Rainer M. Krug, PhD (Conservation Ecology, SUN), MSc (Conservation Biology, UCT), Dipl. Phys. (Germany)

Centre of Excellence for Invasion Biology
Stellenbosch University
South Africa

Tel :       +33 - (0)9 53 10 27 44
Cell:       +33 - (0)6 85 62 59 98
Fax :       +33 - (0)9 58 10 27 44

Fax (D):    +49 - (0)3 21 21 25 22 44

email:      [email-masked]

Skype:      RMkrug

PGP: 0x0F52F982